<?php

include_once plugin_dir_path(__FILE__).'itls-wp-render-class.php';
include_once plugin_dir_path(__FILE__).'itls-wp-prerender-class.php';

    $itls_wc_pay_gw_render = new \Itls\CoreWp\Render();
    $itls_wc_pay_gw_prerender = new \Itls\CoreWp\PreRender();

include_once plugin_dir_path(__FILE__).'options.php';

function ITLS_wc_pay_gw_register_settings_1()
{
    global $itls_wc_pay_gw_x1x_data;
    register_setting($itls_wc_pay_gw_x1x_data['settings_name'], $itls_wc_pay_gw_x1x_data['options_name'], 'ITLS_wc_pay_gw_validate_1');

    if (!get_option($itls_wc_pay_gw_x1x_data['options_name'])) {
        ITLS_wc_pay_gw_do_def($itls_wc_pay_gw_x1x_data['options_name']);
    } else {
        // !!!
    }
}
add_action('admin_init', 'ITLS_wc_pay_gw_register_settings_1');

function ITLS_wc_pay_gw_admin_menu()
{
    global $itls_wc_pay_gw_x1x_data;
    add_menu_page(
        $itls_wc_pay_gw_x1x_data['admin_menu']['page_title'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['menu_name'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['capability'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['menu_slug'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['function'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['icon_url'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['position']
    );
    add_submenu_page(
        $itls_wc_pay_gw_x1x_data['admin_menu']['menu_slug'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['page_title'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['menu_title'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['capability'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['menu_slug']
    );

    add_submenu_page(
        $itls_wc_pay_gw_x1x_data['admin_menu']['menu_slug'],
        $itls_wc_pay_gw_x1x_data['admin_submenu']['page_title'],
        $itls_wc_pay_gw_x1x_data['admin_submenu']['menu_title'],
        $itls_wc_pay_gw_x1x_data['admin_menu']['capability'],
        $itls_wc_pay_gw_x1x_data['admin_submenu']['menu_slug'],
        $itls_wc_pay_gw_x1x_data['admin_submenu']['menu_page']
    );
}
add_action('admin_menu', 'ITLS_wc_pay_gw_admin_menu');

function ITLS_cryptodecpaymentgateway_reset_options_page()
{
    global $itls_wc_pay_gw_x1x_data;
    if (!current_user_can('manage_options')) {
        wp_die(__('You do not have sufficient permissions to access this page.'));
    }
    if (isset($_POST['ITLS_wc_pay_gw_reset_options']) && $_POST['ITLS_wc_pay_gw_reset_options'] === 'true') {
        delete_option($itls_wc_pay_gw_x1x_data['options_name']);
        ITLS_wc_pay_gw_do_def($itls_wc_pay_gw_x1x_data['options_name']);
    }
    include_once('tmpl-reset.php');
}

function ITLS_cryptodecpaymentgateway_options_page()
{
    if (!current_user_can('manage_options')) {
        wp_die(__('You do not have sufficient permissions to access this page.'));
    }
    include_once('tmpl-options.php');
}


function ITLS_wc_pay_gw_validate_1($input)
{
    global $itls_wc_pay_gw_x1x_options;
    if (!current_user_can('manage_options')) {
        wp_die(__('You do not have sufficient permissions to access this page.'));
    }

    foreach ($itls_wc_pay_gw_x1x_options as $tmp_tabs => $tmp_inna) {
        foreach ($tmp_inna['options'] as $tmp_root => $tmp_ara) {
            // if ($tmp_ara['type']=='multifields') continue;
            $input[$tmp_ara['name']] = ITLS_wc_pay_gw_fcheck($tmp_ara['data'], $input[$tmp_ara['name']]);
        }
    }
    return $input;
}

function ITLS_wc_pay_gw_fcheck($t, $v)
{
    $allowed_html = array(
        'h2' => array(),
        'h3' => array(),
        'h4' => array(),
        'br' => array(),
        'em' => array(),
        'strong' => array(),
    );

    switch ($t) {

            case 'bool':
                $v = ($v == 1 ? 1 : 0);
                break;
            case 'text':
                $v =  wp_filter_nohtml_kses($v);
                break;
            case 'html':
                $v =  wp_kses($v, $allowed_html);
                break;
            case 'color':
                $v =  wp_filter_kses($v);
                break;
            case 'int':
                $v =  (int) $v;
                break;
            case 'intpos':
                $v =  (int) $v;
                if ($v < 1) {
                    $v = 1;
                }
                break;
            case 'float':
                $v =  (float) $v;
                break;
            case 'num':
                $v =  preg_replace('/[^0-9.]*/', '', $v);
                break;
            case 'multiselect':
                if (is_array($v)) {
                    $v =  array_map('esc_attr', $v);
                } else {
                    $v = array();
                }
                break;

            case 'btcaddress':
                if (is_array($v)) {
                    //$v =  array_map('esc_attr', $v);
                    //$v = array_map('ITLS_btc_validate', $v);
                    $v = ITLS_btc_validate($v);
                } else {
                    $v =  array($v);//wp_filter_kses($v);
                }
                break;

        }

    return $v;
}

function ITLS_btc_validate($in) {
    $res = array();
    foreach ($in as $k => $v) {
        if ( !preg_match('/^[13][a-km-zA-HJ-NP-Z0-9]{24,42}|bc[a-z0-9]{8,87}/', $v) ) continue;
        if ( empty($v) || $v===null || $v===0 ) continue;
        //if (!empty($v)) {
            $res[] = $v;
        //}
    }
    return $res;
}

function ITLS_wc_pay_gw_do_def($opt)
{
    global $itls_wc_pay_gw_x1x_options;
    $tmp_arr = array();
    foreach ($itls_wc_pay_gw_x1x_options as $tmp_tabs => $tmp_inna) {
        foreach ($tmp_inna['options'] as $tmp_root => $tmp_ara) {
            $kk = $tmp_ara['name'];
            $vv = $tmp_ara['value'];
            $tmp_arr[$kk]=$vv;
        }
    }

    update_option($opt, $tmp_arr);
}

function ITLS_wc_pay_gw_get_json_data($fname, $dt='true')
{
    $ct_raw_config =  @file_get_contents($fname);

    $ct_raw_config = preg_replace('/[\x00-\x1F\x80-\xFF]/', '', $ct_raw_config);
    $ct_raw_config = str_replace('\\', '\\\\', $ct_raw_config);
    $ct_arr_config = json_decode($ct_raw_config, $dt);
    return $ct_arr_config;
}



include_once plugin_dir_path(__FILE__).'scripts.php';
