<?php
namespace Itls\CoreWp;

if (!class_exists('\Itls\CoreWp\PreRender')) {
    class PreRender
    {
        public function __construct()
        {
        }


        public function render_options($opt)
        {
            global $itls_wc_pay_gw_x1x_options, $itls_wc_pay_gw_render, $itls_wc_pay_gw_tabs_exclude;

            $options = get_option($opt);

            echo '<div id="itls-cryptodec-gw-adm-contain"><div class="itls-cryptodec-gw-adm-accordion">';

            foreach ($itls_wc_pay_gw_x1x_options as $tmp_tabs => $tmp_inna) {
                $tmp_tab_name = $tmp_inna['name'];

                if (in_array($tmp_tabs, $itls_wc_pay_gw_tabs_exclude)) {
                    continue;
                }

                echo '<div id="itls-cryptodec-gw-adm-'.$tmp_tabs.'"><a href="#itls-cryptodec-gw-adm-'.$tmp_tabs.'" class="itls-cryptodec-gw-adm-tab">'.$tmp_tab_name.'</a><div class="itls-cryptodec-gw-adm-content"><table class="form-table">';


                foreach ($tmp_inna['options'] as $tmp_root => $tmp_ara) {
                    $tmp_print = '';
                    if (isset($tmp_ara['print'])) {
                        $tmp_print = $tmp_ara['print'];
                    }

                    $tmp_help = '';
                    if (isset($tmp_ara['help'])) {
                        $tmp_help = $tmp_ara['help'];
                    }

                    $field = $this->render_preset_x($tmp_ara['name'], $tmp_print);

                    // $name = '';

                    $value = '';
                    $value = $options[$tmp_ara['name']];
                    /*
                                    if( isset ( $options[$tmp_ara['name']] ) ) {
                                        $value = $options[$tmp_ara['name']];
                                    }
                    */

                    $res = $itls_wc_pay_gw_render->open($field['id'], $field['label'], $tmp_help);

                    switch ($tmp_ara['type']) {

                        case 'tizy':
                            $res.= $itls_wc_pay_gw_render->tizy();
                            break;
                        case 'input':
                            $res.= $itls_wc_pay_gw_render->input($field['id'], $opt.'[' . $field['name'] . ']', $value);
                            break;
                        case 'number':
                            $items = $tmp_ara['items'];
                            $res.= $itls_wc_pay_gw_render->number($field['id'], $opt.'[' . $field['name'] . ']', $value, $items['min'], $items['max'], $items['step']);
                            break;
                        case 'check':
                            if ($value == 1) {
                                $tmp_enabled = __('On');
                            } else {
                                $tmp_enabled = __('Off');
                            }
                            $res.= $itls_wc_pay_gw_render->check($field['id'], $opt . '[' . $field['name'] . ']', $value, $tmp_enabled);
                            break;
                        case 'color':
                            $res.= $itls_wc_pay_gw_render->color($field['id'], $opt.'[' . $field['name'] . ']', $value);
                            break;
                        case 'longtext':
                            $res.= $itls_wc_pay_gw_render->longtext($field['id'], $opt.'[' . $field['name'] . ']', $value);
                            break;
                        case 'media':
                            $res.= $itls_wc_pay_gw_render->media($field['id'], $opt.'[' . $field['name'] . ']', $value);
                            break;
                        case 'multiselect':
                            $field['name']      = $opt."[".$tmp_ara['name']."][]";
                            $xxoptions          = array();

                            foreach ($tmp_ara['items'] as $k => $v) {
                                $selected = '';
                                if (!empty($value)) {
                                    $selected = (in_array($k, $value)) ? $itls_wc_pay_gw_render->multiselect_selected() : '';
                                }
                                $xxoptions[] = $itls_wc_pay_gw_render->multiselect_option($k, $v, $selected);
                            }
                            $res.= $itls_wc_pay_gw_render->multiselect($field['id'], $field['name'], $xxoptions);
                        break;

                        case 'dropdown':
                            $xxoptions          = array();
                            $tmp_option         = '';

                            foreach ($tmp_ara['items'] as $v => $k) {
                                $selected = '';
                                if ($v == $value) {
                                    $selected = $itls_wc_pay_gw_render->dropdown_selected();
                                }
                                $xxoptions[] = $itls_wc_pay_gw_render->dropdown_option($k, $v, $selected);
                            }

                            if (!empty($xxoptions)) {
                                $tmp_option = implode('', $xxoptions);
                            }

                            $res.= $itls_wc_pay_gw_render->dropdown($field['id'], $opt.'[' . $field['name'] . ']', $tmp_option);
                            break;

                            case 'multifields':
                              $field['name']      = $opt."[".$tmp_ara['name']."]";

                              $xxoptions          = array();


                              foreach ($value as $k => $v) {
                                  $xxoptions[$k] = $v;
                              }
                              $xxoptions[] = '';
                              $res.= $itls_wc_pay_gw_render->multifields($field['name'], $xxoptions);

                            break;

                    }

                    $res.= $itls_wc_pay_gw_render->close();
                    echo $res;
                }

                echo '</table></div></div>';
            }

            echo '</div></div>';
        }

        public function render_preset_x($option, $print='')
        {
            global $itls_wc_pay_gw_x1x_data;

            $field['id']        = $itls_wc_pay_gw_x1x_data['prefix'].'_'.$option;

            if ($print=='') {
                $field['label'] = __(ITLS_slug2text($option));
            } else {
                $field['label'] = __($print);
            }

            $field['name']      = $option;

            return $field;
        }
    }
}
