<?php
function ITLS_do_action()
{
    add_action('init', 'ITLS_do_action_x');
}
add_action('init', 'ITLS_do_action_x', 10, 0);

function ITLS_do_action_x()
{
    global $wpdb, $sochain, $woocommerce;
    $tableName = $wpdb->prefix . 'cryptodec_payments';

    $newOrderStatus = 'failed';
    $newCryptoStatus = 'FAILED';
    $hashExists = null;
    $res = null;
    // TODO:: to options::
    $ttl = 60 * 60 * 4; // 4 hours payment awaiting time then cancel.
    $ttlh = 60 * 60 * 48; // 48 hours to get 3+ confirmations

    $query = "SELECT * FROM `$tableName` WHERE `order_status` = 'ONHOLD' OR `order_status` = 'PENDING' ";

    $tmpx = $wpdb->get_results($query);

    if (!$tmpx) {
        return;
    }

    foreach ($tmpx as $key => $result) {
        $address = $result->address;
        $hash = $result->hash;
        $total = $result->order_total;
        $order_id = $result->order_id;
        $order_status = $result->order_status;
        $order_ts = $result->order_ts;
        $rid = $result->id;


        if (strlen($hash)<2) {
            // if hash not given we can try to obtain the hash
            $hash = $sochain->confirm($address, $total);
            if (strlen($hash)>2) {
                $query = "UPDATE `$tableName` SET `hash` = '$hash', `hash_by` = 'SCRIPT' WHERE `order_id` = '$order_id'";
                $wpdb->query($query);
            }
        }

        if (strlen($hash)>2) {
            $res = $sochain->getIn($address, $hash);
        }

        if ($total = $res) {
            // if order status ?? and ttl ???
            $order = wc_get_order($order_id);
            if ($order) {
                $order->update_status('completed', 'Paid with cryptocurrency');
            } else {
                // log this !!!
                return;
            }

            $query = "UPDATE `$tableName` SET `order_status` = 'PAID' WHERE `order_id` = '$order_id'";
            $wpdb->query($query);
        } else {
            if ($res==0 && strlen($hash)>2 && $order_status = 'PENDING') {
                // TODO:  ttl !!!
                $order = wc_get_order($order_id);
                if ($order) {
                    $order->update_status('on-hold', 'Processing Transaction');
                } else {
                    // log this !!!
                    return;
                }
                $query = "UPDATE `$tableName` SET `order_status` = 'ONHOLD' WHERE `order_id` = '$order_id'";
                $wpdb->query($query);
            }
        }

        if ($order_status == 'PENDING') {
            $curr_time = time();
            $order_ttl = $order_ts + $ttl;
            if ($order_ttl < $curr_time) {
                $order = wc_get_order($order_id);
                if ($order) {
                    $order->update_status('cancelled', 'Payment not made.');
                } else {
                    return;
                }

                $query = "UPDATE `$tableName` SET `order_status` = 'CANCELLED' WHERE `order_id` = '$order_id'";
                $wpdb->query($query);
            }
        }

        if ($order_status == 'ONHOLD') {
            $curr_time = time();
            $order_ttlh = $order_ts + $ttlh;
            if ($order_ttlh < $curr_time) {
                $order = wc_get_order($order_id);
                if ($order) {
                    $order->update_status('failed', 'Payment not confirmed.');
                } else {
                    return;
                }

                $query = "UPDATE `$tableName` SET `order_status` = 'FAILED' WHERE `order_id` = '$order_id'";
                $wpdb->query($query);
            }
        }

    } // loop
}
