<?php
namespace Itls\Crypto;

if (!class_exists('\Itls\Crypto\Btc')) {
    class Btc
    {
        public function __construct()
        {
        }

        public function btc2Satoshi($value)
        {
            return ($value)*(pow(10, 8));
        }

        public function satoshi2Btc($value)
        {
            return number_format(($value)*(pow(10, -8)), 8, '.', '');
        }

        public function getBtcAmount($cart_total, $curr_code)
        {
            $res = $cart_total;
            if ($curr_code!='BTC') {
                $bcinfo = $this->getRemote("https://blockchain.info/ticker");
                if (!array_key_exists($curr_code, $bcinfo)) {
                    $res = -1;
                } else {
                    //$dust = rand(12,38) / 100; // !!!
                        $dust = rand(32, 78) / 100; // !!!
                        $res = ($cart_total+$dust) / $bcinfo[$curr_code]['last'];
                    $res = number_format($res, 8, '.', '');
                }
            }
            return $res;
        }

        public function getRemote($url)
        {
            // remote data
            $response = wp_remote_get($url);

            if (is_wp_error($response) || !isset($response['body'])) {
                return;
            } // bad response

            // the good stuff
            $body = wp_remote_retrieve_body($response);

            if (is_wp_error($body)) {
                return;
            } // bad body

            // decode the data
            $data = json_decode($body, true);

            if (!$data || empty($data)) {
                return;
            } // bad data

            // final remote data
            return $data;
        }
    }
}
