<?php
namespace Itls\CryptoWp;

include_once plugin_dir_path(__FILE__) . '../lib/qrlib/autoload.php';
include_once plugin_dir_path(__FILE__) . '../lib/btclib/autoload.php';

include_once plugin_dir_path(__FILE__) . 'itls-hd.php';

use chillerlan\QRCode\{QRCode, QROptions};

if (!class_exists('\Itls\CryptoWp\Btc')) {
    class Btc
    {
        public function __construct()
        {
            $this->id = 'ITLS_btc';
            $this->icon = plugin_dir_url(__FILE__) . '../assets/images/btc-logo.png';
        }

        public function get_btc_addr()
        {
            global $itls_wc_pay_gw_x1x_data, $itls_wp_helper;
            $ret = false;
            $oName = $itls_wc_pay_gw_x1x_data['options_name'];
            $options = get_option($oName);

            if ($itls_wp_helper->checkUserData()) {
                $ret = $itls_wp_helper->getUserData();
            } else {
              $zpub = $options['itls_crypto_btc_zpub'];
              $user_id = get_current_user_id();
              $index = (int)$user_id;
              $path = '0/'.strval($index);

              $hd = new \Itls\CryptoWp\Hd();
              $hd->set_zpub($zpub);
              $tRet = $hd->address_from_master_pub($path);

              if (strlen($tRet) > 15) {
                  $ret = $tRet;
                  $itls_wp_helper->putUserData($ret);
              }

            }
            return $ret;
        }

        public function get_qr_code($walletAddress, $cryptoTotal, $coin='bitcoin')
        {
            $qrData = $coin.':'.$walletAddress.'?amount='.$cryptoTotal;
            $res = (new QRCode)->render($qrData);
            return $res;
        }
    }
}
