<?php

function cryptodec_checkout_process()
{
    global $itls_wc_pay_gw_x1x_data;

    if ($_POST['payment_method'] != 'cryptodec_gateway') {
        return;
    }

    //$txid_force = true;

    $oName = $itls_wc_pay_gw_x1x_data['options_name'];
    $options = get_option($oName);
    $txid_force = $options['itls_txid_force'];

    $cryptodec_transaction_id = sanitize_text_field($_POST['cryptodec_transaction_id']);

    if ($txid_force) {
        if (!isset($cryptodec_transaction_id) || empty($cryptodec_transaction_id)) {
            wc_add_notice(esc_html__('Please enter your transaction ID', 'decentralized-bitcoin-cryptodec-payment-gateway-for-woocommerce'), 'error');
        } else {
            if (ITLS_cd_is_hash_count($cryptodec_transaction_id) > 0) {
                wc_add_notice(esc_html__('This Transaction ID has been already processed, please provide another Transaction ID', 'decentralized-bitcoin-cryptodec-payment-gateway-for-woocommerce'), 'error');
            }
        }
    }

    $wallet = sanitize_text_field($_POST['cryptodec_best_btc_wallet']);
    $total = sanitize_text_field($_POST['cryptodec_total']);
    $coin = sanitize_text_field($_POST['cryptodec_coin']);

    $match_id = isset($cryptodec_transaction_id) ? $cryptodec_transaction_id : '';
    $validate_id = preg_match('/^[0-9a-fA-F]{2,}$/i', $match_id);

    if (!empty($cryptodec_transaction_id) && $validate_id == false) {
        wc_add_notice(esc_html__('Only HEX HASH is acceptable', 'decentralized-bitcoin-cryptodec-payment-gateway-for-woocommerce'), 'error');
    }
}

    add_action('woocommerce_checkout_process', 'cryptodec_checkout_process');

    function action_checkout_order_processed($order_id, $posted_data, $order)
    {
        //TODO: check if wallet is ours!
        //      check if amount is adequate
        //      before adding to db !!!
        //      fix coin !!!
        $hash_by = 'NOPE';
        $coin = 'BTC';
        $status = 'PENDING';

        $wallet = get_post_meta($order_id, '_cryptodec_best_btc_wallet', true);
        $total = get_post_meta($order_id, '_cryptodec_total', true);
        $hash = get_post_meta($order_id, '_cryptodec_transaction_id', true);

        if (ITLS_cd_is_hash_count($hash) > 0) {
            $hash = '';
        }

        if (strlen($hash) > 15) {
            $hash_by = 'USER';
        }
        ITLS_cd_put_payment($wallet, $coin, $order_id, $total, $hash, $hash_by, $status);
    }
    add_action('woocommerce_checkout_order_processed', 'action_checkout_order_processed', 10, 3);

    /**
     * Update CryptoDec field to database
     */
    function cryptodec_additional_field_update($order_id)
    {
        if ($_POST['payment_method'] != 'cryptodec_gateway') {
            return;
        }

        $cryptodec_transaction_id = sanitize_text_field($_POST['cryptodec_transaction_id']);
        $cryptodec_best_btc_wallet = sanitize_text_field($_POST['cryptodec_best_btc_wallet']);
        $cryptodec_total = sanitize_text_field($_POST['cryptodec_total']);
        $cryptodec_coin = sanitize_text_field($_POST['cryptodec_coin']);


        $transaction = isset($cryptodec_transaction_id) ? $cryptodec_transaction_id : '';
        $wallet = isset($cryptodec_best_btc_wallet) ? $cryptodec_best_btc_wallet : '';
        $total = isset($cryptodec_total) ? $cryptodec_total : '';
        $coin = isset($cryptodec_coin) ? $cryptodec_coin : '';

        update_post_meta($order_id, '_cryptodec_transaction_id', $transaction);
        update_post_meta($order_id, '_cryptodec_best_btc_wallet', $wallet);
        update_post_meta($order_id, '_cryptodec_total', $total);
        update_post_meta($order_id, '_cryptodec_coin', $coin);
    }

    add_action('woocommerce_checkout_update_order_meta', 'cryptodec_additional_field_update');



    /**
     * Admin order page CryptoDec data output
     */
    function cryptodec_admin_order_data($order)
    {
        if ($order->get_payment_method() != 'cryptodec_gateway') {
            return;
        }

        $tmpMyOrderID = $order->get_id(); // $order->id !!!

        $my_wallet = get_post_meta($tmpMyOrderID, '_cryptodec_best_btc_wallet', true);
        $my_total = get_post_meta($tmpMyOrderID, '_cryptodec_total', true);
        $transaction = get_post_meta($tmpMyOrderID, '_cryptodec_transaction_id', true); ?>
        <div class="form-field form-field-wide">
            <img src='<?php echo plugin_dir_url(__FILE__) . '../assets/images/logo-gw.png'; ?>' alt="CryptoDec">
            <table class="wp-list-table widefat fixed striped">
                <tbody>
                    <tr>

                        <th><?php esc_html_e('BTC Wallet ID:', 'decentralized-bitcoin-cryptodec-payment-gateway-for-woocommerce'); ?></th>
                        <td><?php echo "<a href='https://www.blockchain.com/btc/address/".esc_attr($my_wallet)."' target='_blank' >".esc_attr($my_wallet)."</a>"; ?></td>

                        <th><?php esc_html_e('Total:', 'decentralized-bitcoin-cryptodec-payment-gateway-for-woocommerce'); ?></th>
                        <td><?php echo esc_attr($my_total); ?></td>

                        <th><strong><?php esc_html_e('Transaction ID :', 'decentralized-bitcoin-cryptodec-payment-gateway-for-woocommerce') ; ?></strong></th>
                        <td><?php echo "<a href='https://www.blockchain.com/btc/tx/".esc_attr($transaction)."' target='_blank' >".esc_attr($transaction)."</a>"; ?></td>
                    </tr>
                </tbody>
            </table>
        </div>
<?php
    }

    add_action('woocommerce_admin_order_data_after_billing_address', 'cryptodec_admin_order_data');

    add_action('woocommerce_thankyou', 'cryptodec_view_order_and_thankyou_page', 20);
    add_action('woocommerce_view_order', 'cryptodec_view_order_and_thankyou_page', 20);

    function cryptodec_view_order_and_thankyou_page($order_id)
    {
        global $itls_btc_wp;
        $payment = get_post_meta($order_id, '_payment_method', true);
        $wallet = get_post_meta($order_id, '_cryptodec_best_btc_wallet', true);
        $amount = get_post_meta($order_id, '_cryptodec_total', true);
        $txid = get_post_meta($order_id, '_cryptodec_transaction_id', true);
        $qrCode = $itls_btc_wp->get_qr_code($wallet, $amount, 'bitcoin'); // 0 !!!

        $order = wc_get_order($order_id);
        $status = $order->get_status();

        if ($payment != 'cryptodec_gateway') {
            return;
        } ?>
        <h2>Crypto DEC</h2>
        <table class="woocommerce-table shop_table gift_info">
            <tbody>
              <tr>
                  <th>Wallet Address</th>
                  <td><?php echo esc_attr($wallet); ?></td>
              </tr>
              <tr>
                  <th>Amount</th>
                  <td><?php echo esc_attr($amount); ?></td>
              </tr>
              <tr>
                  <th>Transaction ID</th>
                  <td><?php echo esc_attr($txid); ?></td>
              </tr>
              <tr>
<?php
if ($status!=='completed') {
            ?>
                  <th>QR Code</th>
                  <td><img height="120" width="120" style="display: block;  max-width:120px;  max-height:120px;  width: auto;  height: auto;" src=<?php echo $qrCode; ?> alt="<?php echo $wallet; ?>" /></td>
<?php
        } else {
?>

                  <th>Date Paid</th>
                  <td><?php echo $order->get_date_paid(); ?></td>

<?php
        }
?>
              </tr>
            </tbody>
        </table>
<?php
}

add_action('show_user_profile', 'cryptodec_user_profile_field');
add_action('edit_user_profile', 'cryptodec_user_profile_field');

function cryptodec_user_profile_field($user)
{
    $tmp = '';
    if (!current_user_can('edit_user', $user->ID)) {
        $tmp = ' disabled';
    } ?>
    <h3>CryptoDEC</h3>
    <table class="form-table">
        <tr>
            <th><label for="best_btc_wallet">BTC Wallet Assigned:</label></th>
            <td>
                <input name="best_btc_wallet" id="best_btc_wallet" value="<?php echo esc_attr(get_the_author_meta('best_btc_wallet', $user->ID)); ?>" class="regular-text" type="text" <?php echo $tmp; ?>>
            </td>
        </tr>
    </table>
<?php
}

add_action('edit_user_profile_update', 'save_cryptodec_user_profile_field');
function save_cryptodec_user_profile_field($user_id)
{
    if (current_user_can('edit_user', $user_id)) {
        update_user_meta(absint($user_id), 'best_btc_wallet', wp_kses_post($_POST['best_btc_wallet']));
    } else {
        return false;
    }
}

//add_filter( 'woocommerce_email_order_meta_fields', 'cryptodec_woocommerce_email_order_meta_fields', 10, 3 );

function cryptodec_woocommerce_email_order_meta_fields( $fields, $sent_to_admin, $order ) {

    $tmpMyOrderID = $order->get_id(); // $order->id !!!
    $fields['best_btc_wallet'] = array(
        'label' => __( 'Wallet Address' ),
        'value' => get_post_meta( $tmpMyOrderID, '_cryptodec_best_btc_wallet', true ),
    );
    $fields['order_total'] = array(
        'label' => __( 'Total BTC' ),
        'value' => get_post_meta( $tmpMyOrderID, '_cryptodec_total', true ),
    );
    return $fields;
}

add_action( 'woocommerce_email_after_order_table', 'cryptodec_woocommerce_email_after_order_table_func' );
function cryptodec_woocommerce_email_after_order_table_func( $order ) {

    $tmpMyOrderID = $order->get_id(); // $order->id !!!
?>

	<h3>Bitcoin Payment Details</h3>
	<table>
		<tr>
			<td>Bitcoin Wallet Address: </td>
			<td><?php echo wptexturize( get_post_meta( $tmpMyOrderID, '_cryptodec_best_btc_wallet', true ) ); ?></td>
		</tr>
		<tr>
			<td>Amount in BTC to transfer: </td>
			<td><?php echo wptexturize(  get_post_meta( $tmpMyOrderID, '_cryptodec_total', true ) ); ?></td>
		</tr>
		<tr>
			<td>Note: </td>
			<td>Please transfer Exact amount.</td>
		</tr>
	</table>

<?php
}
