<?php
namespace Itls\Core;

if (!class_exists('\Itls\Core\WpHelper')) {
    class WpHelper
    {
        public function __construct()
        {
        }

        public function checkUserData()
        {
            $res = false;
            $user_id = get_current_user_id();
            $key = 'best_btc_wallet';
            $single = true;
            $user_best_wallet = get_user_meta($user_id, $key, $single);
            if (!empty($user_best_wallet)) {
                $res = true;
            }
            return $res;
        }

        public function getUserData()
        {
            $res = null;
            $user_id = get_current_user_id();
            $key = 'best_btc_wallet';
            $single = true;
            $user_best_wallet = get_user_meta($user_id, $key, $single);
            if (!empty($user_best_wallet)) {
                $res = $user_best_wallet;
            }
            return $res;
        }

        public function putUserData($user_best_wallet)
        {
            $unique = true;
            $user_id = get_current_user_id();
            $key = 'best_btc_wallet';
            add_user_meta($user_id, $key, $user_best_wallet, $unique);
        }

        public function delUserData()
        {
            $unique = true;
            $user_id = get_current_user_id();
            $key = 'best_btc_wallet';
            delete_user_meta($user_id, $key);
        }

        /**
         * Pull the feed
         */
        public function getRemote($url)
        {
            // remote data
            $response = wp_remote_get($url);

            if (is_wp_error($response) || !isset($response['body'])) {
                return;
            } // bad response

            // the good stuff
            $body = wp_remote_retrieve_body($response);

            if (is_wp_error($body)) {
                return;
            } // bad body

            // decode the data
            $data = json_decode($body, true);

            if (!$data || empty($data)) {
                return;
            } // bad data

            // final remote data
            return $data;
        }
    }
}
